#include once "windows.bi"
deflng a-z

' screensaver preview part
' bmp buffer (152 * 112 * 24bit bmp)
dim shared bmppict(0 to  51126-1) as ubyte     
' bmp header (first 54 bytes of bmp)
dim shared hdrpict(0 to  54-1) as ubyte = { _
 66, 77,182,199,  0,  0,  0,  0,  0,  0, 54,  0,  0,  0, 40,  0,_
  0,  0,152,  0,  0,  0,112,  0,  0,  0,  1,  0, 24,  0,  0,  0,_
  0,  0,128,199,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,_
  0,  0,  0,  0,  0,  0}

declare function        WinMain     ( byval hInstance as HINSTANCE, _
                                      byval hPrevInstance as HINSTANCE, _
                                      byval szCmdLine as string, _
                                      byval iCmdShow as integer ) as integer
                                  

'Program entry point                                  
'':::::
	end WinMain( GetModuleHandle( null ), null, Command( ), SW_NORMAL )
'':::::

'':::::
function WndProc ( byval hWnd as HWND, _
                   byval wMsg as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT
    
	dim as RECT rect
   
    dim pbmppict as ubyte ptr,picwidth as DWORD,picheight as DWORD

    function = 0
    
    select case( wMsg )
' update video frames on timer
        case WM_TIMER
' timer 1 ?
	    if wParam=1 then
' fill bmp buffer by new video frame
            nextframe
	        GetClientRect( hWnd, @rect )
	        InvalidateRect(hWnd,@rect,0)
            end if
            exit function
		
        case WM_CREATE            
        	GetClientRect( hWnd, @rect )
        	
            exit function
' repaint preview video       
        case WM_PAINT
            dim as PAINTSTRUCT pnt
    	    dim as HDC hDC
            hDC = BeginPaint( hWnd, @pnt )
            GetClientRect( hWnd, @rect )
	    pbmppict=@bmppict(0)
dataoffset=  bmppict(10)+256*bmppict(11)
picwidth  = (bmppict(18)+256*bmppict(19)) and 2047
picheight = (bmppict(22)+256*bmppict(23)) and 2047
' draw bmp image on screen 
r1=SetDIBitsToDevice(hDC,0,0,picwidth,picheight,0,0,0,picheight,_
                     pbmppict+dataoffset,cast(BITMAPINFO ptr,pbmppict+14),DIB_RGB_COLORS)
            EndPaint( hWnd, @pnt )
            exit function            
        
' ** Unused **
'Drag window by mouse
'		case WM_LBUTTONDOWN
'			SendMessage( hWnd, WM_NCLBUTTONDOWN, HTCAPTION, NULL )

' Exit on ESC (no need for screensaver /p mode)
'		case WM_KEYDOWN
'			if( lobyte( wParam ) = 27 ) then
'				PostMessage( hWnd, WM_CLOSE, 0, 0 )
'				exit function
'			end if


' Screensaver in preview mode has not any exit button and still exits via this case
    	case WM_DESTROY
            PostQuitMessage( 0 )
            exit function
    end select
    
    function = DefWindowProc( hWnd, wMsg, wParam, lParam )    
    
end function

' Create window without frame
' FreeBasic hello_region.bas example was used for this sub
'':::::
sub remove_caption(byval hwnd as HWND )
	dim as RECT rect

  	dim as integer style = GetWindowLong( hwnd, GWL_STYLE ) and (not WS_CAPTION)
  	SetWindowLong( hwnd, GWL_STYLE, style ) 
  	GetClientRect( hwnd, @rect )
  	AdjustWindowRect( @rect, style, cast( BOOL, GetMenu( hwnd ) ) ) 
  	SetWindowPos( hwnd, 0, 0, 0, rect.Right, rect.Bottom, _
				  SWP_NOMOVE or SWP_NOZORDER or SWP_FRAMECHANGED or SWP_NOSENDCHANGING )
end sub



'':::::
function WinMain ( byval hInstance as HINSTANCE, _
                   byval hPrevInstance as HINSTANCE, _
                   byval szCmdLine as string, _
                   byval iCmdShow as integer ) as integer    
     
    dim as MSG wMsg 
    dim as WNDCLASS wcls 
    dim as HWND hWnd 

    function = 0
     
    with wcls
    	.style         = CS_HREDRAW or CS_VREDRAW
    	.lpfnWndProc   = @WndProc
    	.cbClsExtra    = 0
    	.cbWndExtra    = 0
    	.hInstance     = hInstance
    	.hIcon         = NULL 'LoadIcon( NULL, IDI_APPLICATION )
    	.hCursor       = LoadCursor( NULL, IDC_ARROW)
    	.hbrBackground = GetStockObject( LTGRAY_BRUSH )
    	.lpszMenuName  = NULL
    	.lpszClassName = @"Red Alice ScreenSaver"
    end with

        cmd$=lcase$(szCmdLine)
' /c in command line - screensaver configure
        p=instr(cmd$,"/c")
        if p<>0 then end FreeControl'(szCmdLine)
' screencaver normal
        p=instr(cmd$,"/p")
	if p=0 then end FreeSaver' (szCmdLine)
' screensaver preview
' command switch: "/p parentnumber" as text
        parent=0:if p>0 then parent=val(mid$(cmd$,p+2))
' no parent number - invalid
	if parent=0 then exit function
' copy bmp header to bmp picture
    for i=0 to 53:bmppict(i)=hdrpict(i):next i
' use GDI, not FreeBasic graphics library
    usegdi=-1
' load archive
    loaddata
' random starting video frame
    randomize timer
    videoframe=int(1.0*rnd*25*cnt)
' create window
    if( RegisterClass( @wcls ) = FALSE ) then
'       MessageBox( null, "Failed to register wcls!", "Error", MB_ICONERROR )
       exit function
    end if
    
    hWnd = CreateWindowEx( 0, _
    			   "Red Alice ScreenSaver", _
                           NULL, _
                           0*WS_OVERLAPPED+WS_CHILD, _
                           0, _
                           0, _
                           152, _
                           112, _
                           cast(HWND,parent), _
                           cast(HMENU,9999), _
                           hInstance, _
                           NULL )
                          
    remove_caption( hWnd )
    
    ShowWindow( hWnd, iCmdShow )
    UpdateWindow( hWnd )
' create timer #1, 160 milliseconds timer period to update video
    SetTimer(hwnd,1,160,0)
    while( GetMessage( @wMsg, NULL, 0, 0 ) <> FALSE )    
        TranslateMessage( @wMsg )
        DispatchMessage( @wMsg )
    wend
    
    function = wMsg.wParam

end function

