'freebasic
' Freebasic 0.20 , -fblite mode (see !make.bat)
' (C) Dmitriy Korabelnikov aka Deckard of Atomic Destruction 14 April 2008
' Decoding video from JPG files (based on Intel JPEG Library)
#include once "windows.bi"
#include once "ijl.bi"
REM #define DEMOVERSION

deflng a-z

' sub and function prototypes


declare sub echo(img as any ptr,x0 as long,y0 as long,txt as zstring ptr)
declare function mousemove as long
declare sub swaprgb(pic as ulong ptr,xs as long,ys as long)
declare function jpgload(pp as long,ll as long) as long
declare sub blackdelay
declare sub loaddata
declare sub nextframe2
declare sub nextframe
declare function FreeSaver as long
declare sub CreateSlider(n as long,x as long,y as long,tx$)
declare sub UpdateSliders(mx as long,my as long)
declare sub createbutton(n as long,x as long,y as long,tx$)
declare sub UpdateButtons(mx as long,my as long)
declare sub wrtini
declare sub readini
declare function FreeControl as long


'

' slider control
type controltype
x0 as long
y0 as long
cx as long
cy as long
h as long
w as long
value as long
valuescaled as long
active as long
end type

' button control
type buttontype
x0 as long
y0 as long
h as long
w as long
value as long
active as long
end type

' reserve some space for sliders and buttons
dim shared ctrl(10) as controltype
dim shared button(10) as buttontype

' Show video (seconds) 
dim shared as long avideomax(8)={5,5,10,10,15,15,20,20,20}
' Blank screen (seconds, 0 - no blank)
dim shared as long adarkmax(8)= {0,5,10,15,20,30,60,90,90}
' dotmode - draw video as dots or horisontal lines
dim shared as long videomax,darkmax,dotmode,brightness




' record type of archive data (32 bytes)
type rectype
nam as zstring*40
p as long
l as long
end type

const nrec=32

' archive header (&h600 bytes, see ROZENSCR file)
dim shared rec(nrec) as rectype
dim shared recptr as ubyte ptr

dim shared as long mousex0=-1,mousey0=-1,exitflag

dim shared imgw,imgh

' pointers and lenghts of data items
dim shared as long pp(nrec),ll(nrec)
' current frave of video
dim shared videoframe
' pointer to archive in memory
dim shared as ubyte ptr arcmem
' used by Intel Jpeg Library 
Dim shared jcprops As JPEG_CORE_PROPERTIES
' pointer to unpacked "big" (w=1024,h=768) image
dim shared as ulong ptr jpgout 
' pointer to "small" (w=256,h=192) image
dim shared as ulong ptr imgbuf1
' Intel Jpeg Library handle
dim shared ijlib as any ptr

dim shared exename$,tmpdir$
' cnd - total number of Jpeg images, frgroup0 - nubmer of Jpeg in unpacked state
dim shared as long cnt,frgroup0=-1

' font variables
dim shared vgafix as ubyte ptr
dim shared as ulong textfg=rgba(255,255,255,255),textbg=0,texth=1

dim shared useGDI as long

' code for screensaver in preview mode
#include once "redalicew.bi"

sub gdipset(x0 as long,y0 as long,c as long)
dim p1 as ubyte ptr
dim d as ubyte
w=152:h=112
if x0<0 or y0<0 then exit sub
if x0>=w or y0>=h then exit sub
p1=@bmppict(0)+&h36+3*(x0+w*(h-1-y0))
d=c and &hff:*p1=d:p1+=1
d=(c shr 8) and &hff:*p1=d:p1+=1
d=(c shr 16) and &hff:*p1=d:p1+=1
end sub

'@ print text to image img using raster font
sub echo(img as any ptr,x0 as long,y0 as long,txt as zstring ptr)
' if font not loaded, then load font (256-32 symbols, b/w, 13 byte per symbol)
if vgafix=0 then
' simply load data from resource 
  vgafix=LockResource(LoadResource(0,FindResource(0,"VGAFIX","CODE")))
' vgafix=allocate(2912):open exepath+"\coure.bin" for input as #3:get #3,,vgafix[0],2912:close #3
' make a "future font" effect (see computers and films from 1980's)
' the upper part of letter is normal, the lower part of letter is bold
  for j=0 to 255-32
  p=13*j
  for i=6 to 12
  d=vgafix[p+i]
  vgafix[p+i]=d or ((d shl 1) and 255)
  next i
  next j
end if

x=x0:y=y0+2:n=0
' print text
do
d=txt[n]
' chr$(0) - end of text
if d=0 then exit sub
' chr$(10) - new line, chr$(13) - ignored
if d=10 then
x=x0-8:y+=16*texth
end if
' normal letter
if d>=32 then
bt=(d-32)*13
for j=0 to 12
' bit mask
m=128
q=vgafix[bt+j]
' print a letter
for i=0 to 7
if q and m then col=textfg else col=textbg
for z=0 to texth-1
if useGDI=0 then
  pset img,(x+i,y+j*texth+z),col
else
  gdipset(x+i,y+j*texth+z,col)
end if
next z
m=m shr 1
next i
next j
end if    
' next horisontal position
x=x+8
' next letter
n=n+1
loop
end sub    

'@ polls mouse.
' Returns -1 if mouse button was pressed or mouse was moved for more then 8 pixels
' (used to exit from screensaver)
function mousemove as long
if mousex0<0 or mousey0<0 then
    getmouse mousex0,mousey0,,buttons
    mousemove=0
else
    getmouse mx,my,,buttons
    q=0
    if buttons<>0 then q=-1
    if not (mousex0<0 or mousey0<0) then
        if abs(mx-mousex0)>8 or abs(my-mousey0)>8 then q=-1
    end if
    mousemove=q
end if
end function

'@ swap Red in Blue bytes in image buffer 
sub swaprgb(pic as ulong ptr,xs as long,ys as long)
dim d as ulong
c=xs*ys
if useGDI=0 then
for i=1 to c
  d=*(pic+i)
  r=(d and &hfC)*brightness/256
  g=((d shr 8) and &hfC)*brightness/256
  b=((d shr 16) and &hfC)*brightness/256
  *(pic+i)=rgb(r,g,b)
next i    
else
for i=1 to c
  d=*(pic+i)
  r=d and &hfC
  g=(d shr 8) and &hfC
  b=(d shr 16) and &hfC
  *(pic+i)=rgb(r,g,b)
next i
end if
end sub


'@ decode JPG from memory
' pp - pointer to Jpeg image, ll - length of jpeg image
function jpgload(pp as long,ll as long) as long
jerr = ijlInit(jcprops)
if jerr<>0 then jpgload=jerr:exit function
' pointer to JPG
jcprops.JPGBytes=cast(long,arcmem+pp)
' length of JPG
jcprops.JPGSizeBytes=ll
' Read JPG header only
jerr = ijlRead(jcprops, IJL_JFILE_READPARAMS or 1)
imgw = jcprops.JPGWidth
imgh = jcprops.JPGHeight
' Allocate output buffer
if jpgout=0 then
' When we use GDI (in screensaver preview mode), we can't use ImageCreate function from FreeBasic 
  if usegdi=0 then jpgout=imagecreate(imgw,imgh,0) else jpgout=allocate(4*(1+imgw*imgh)+256)
end if
' unpack colour Jpeg to RGBA image
jcprops.JPGColor = IJL_YCBCR
jcprops.DIBColor = IJL_RGBA_FPX
jcprops.DIBWidth = imgw
jcprops.DIBHeight = imgh
jcprops.DIBChannels = 4
jcprops.DIBBytes=cast(long,jpgout+1)
jcprops.DIBPadBytes = IJL_DIB_PAD_BYTES(jcprops.DIBWidth, jcprops.DIBChannels)
jerr = ijlRead(jcprops, IJL_JFILE_READWHOLEIMAGE or 1)
' We don't use swaprgb here because image is too large
' To make program faster, we get one videoframe from mosaic, then apply swaprgb to "small" image
swaprgb(jpgout,imgw,imgh)
jerr = ijlFree(jcprops)
jpgload=0    
end function

'@ blank screen completely 
sub blackdelay
dim time0 as double
dim y0 as long:dim y1 as long
y0=0:y1=1
time0=timer
cls
' delay for darkmax seconds
while time0+darkmax > timer
if inkey$<>"" or mousemove then end
t$=time$
echo 0,(1024-len(t$)*8)/2,(768-16)/2+y0,t$
y0=y0+y1
if y0>=32 then y1=-1
if y0<=0 then y1=1
sleep 100    
wend
end sub


'@ load archive from resource to memory
sub loaddata
' Directory for tmp files
tmpdir$=environ$("TMP"):if right$(tmpdir$,1)<>"\" then tmpdir$=tmpdir$+"\"
' load
arcmem=LockResource(LoadResource(0,FindResource(0,"GRAF","CODE")))
'open exepath+"\rozenscr" for binary as #1:le=lof(1)
'arcmem=allocate(le):get #1,1,*arcmem,le:close #1

' to prevent program crash if something goes wrong
if *(arcmem+48)<>&h69 or *(arcmem+49)<>&h6a then ' "ij" bytes
  ? "bad archive link":sleep:end
end if

' read archive directory (32*64=2048 bytes)
recptr=cast(ubyte ptr, @rec(0))
for i=0 to (nrec-1)*48:*(recptr+i)=*(arcmem+i):next i

cnt=-1
for i=1 to nrec-1
n$=rec(i).nam
if n$="" then exit for
' jpg image in archive ?
if instr(n$,".jpg") then
    cnt+=1
    pp(cnt)=rec(i).p
    ll(cnt)=rec(i).l
end if
' ijl10.dll in archive ? - copy to TMP directory
if instr(n$,".dll") then
    open tmpdir$+n$ for binary as #3
    put #3,,*(arcmem+rec(i).p),rec(i).l
    close #3
' Load JPEG dll and import dll functions
    ijlib=DYLIBLOAD(tmpdir$+"ijl10.dll")

    ijlInit=dylibsymbol(ijlib,"ijlInit")
    ijlFree=dylibsymbol(ijlib,"ijlFree")
    ijlRead=dylibsymbol(ijlib,"ijlRead")
    ijlWrite=dylibsymbol(ijlib,"ijlWrite")
    ijlGetLibVersion=dylibsymbol(ijlib,"ijlGetLibVersion")
    ijlErrorStr=dylibsymbol(ijlib,"ijlErrorStr")
end if
next i
end sub


'@ Next video frame using GDI
sub nextframe
dim p0 as ulong ptr
dim p1 as ubyte ptr
dim as ulong d
dim as ubyte r,g,b
videoframe+=1
if videoframe>(cnt*25) then videoframe=1
tmp=videoframe-1
tick=tmp mod 25
x=tmp mod 5:tmp=int(tmp/5)
y=tmp mod 5:frgroup=1+int(tmp/5)
' Do we need to unpack new jpeg ?
if frgroup0<>frgroup then
   jpgload pp(frgroup),ll(frgroup)
   frgroup0=frgroup
end if
dx=(imgw/xpart-152)/2
dy=(imgh/ypart-112)/2
' coords of upper right corner on src picture
x0=dx+x*imgw/xpart
y0=dy+y*imgh/ypart

' rozen maiden fix
x0=0:y0=0

' copy image to (w=152,h=112) preview BMP (see redalicew.bi)

maxj=111

if demomode=0  or ((videoframe mod 100)>40) then
for j=0 to maxj
p0=jpgout+1+imgw*(y0+6*j)+x0
p1=@bmppict(0)+&h36+3*152*(111-j)
for i=0 to 151
d=*p0:p0+=6
' This byte order (RGBA, lsb first) !
r=d and &hFC:g=(d shr 8) and &hFC:b=(d shr 16) and &hFC
*p1=r*tick/32:p1+=1
*p1=g*tick/32:p1+=1
*p1=b*tick/32:p1+=1
next i
next j
else
for j=0 to maxj
p0=jpgout+1+imgw*(y0+6*j)+x0
p1=@bmppict(0)+&h36+3*152*(111-j)
for i=0 to 151
d=*p0:p0+=6
r=d and &hFC:g=0:b=0
*p1=r*tick/32:p1+=1
*p1=g*tick/32:p1+=1
*p1=b*tick/32:p1+=1
next i
next j
end if
'echo (0,0,0,"Hello "+str$(tick))
end sub

'@ Next video frame using GDI
sub nextframe2
dim p0 as ulong ptr
dim as ulong d
dim as ubyte r,g,b
videoframe+=1
if videoframe>(cnt*25) then videoframe=1
tmp=videoframe-1
tick=tmp mod 25
x=tmp mod 5:tmp=int(tmp/5)
y=tmp mod 5:frgroup=1+int(tmp/5)
' Do we need to unpack new jpeg ?
if frgroup0<>frgroup then
   jpgload pp(frgroup),ll(frgroup)
   frgroup0=frgroup
end if

if imgbuf1=0 then imgbuf1=imagecreate(256,192)

' rozen maiden fix
x0=0:y0=0

' copy image to (w=256,h=192) preview

maxj=191

for j=0 to maxj
p0=jpgout+1+imgw*(y0+4*j)+x0
for i=0 to 255
d=*p0:p0+=4
' This byte order !
b=d and &hFC:g=(d shr 8) and &hFC:r=(d shr 16) and &hFC
r=r*tick/32
g=g*tick/32
b=b*tick/32
pset imgbuf1,(i,j),rgb(r,g,b)
next i
next j
end sub


'@ main function of screensaver (see redalicew.bi - how this function is called)
function FreeSaver as long
dim time0 as double
dim slide as long
screenres 1024,768,32,1,1
' hide mouse
setmouse 512,384,0,0
readini
loaddata
getmouse mousex0,mousey0,,buttons
' randomize starting video frame
randomize timer
videoframe=int(1.0*rnd*25*cnt)
slide=int(1.0*rnd*cnt)

' main loop
time0=timer
while 1
if timer-time0>videomax then
  if darkmax then blackdelay
  time0=timer
end if
' get video frame
'nextframe2
'for i=0 to cnt
jpgload pp(slide),ll(slide)
slide=(slide+1) mod cnt
for j=0 to 255 step 8
put (0,0),jpgout,alpha,j
sleep 20
next j
for j=1 to 10
sleep 100
if inkey$<>"" or mousemove then end
next j
wend
FreeSaver=0
end function

'==========================================================
' Configuration (/C command switch) part of screensaver

'@ create slider
sub CreateSlider(n as long,x as long,y as long,tx$)
le=len(tx$)
'locate 1+y,x-le:print tx$;
echo(0,(x-le-1)*8,y*8-4,tx$)
with ctrl(n)
.cy=y
.cx=x+14
.active=1
.x0=8*x
.y0=8*y
.w=100
.h=8
if .value<0 then .value=0
if .value>99 then .value=99
line(.x0-.h/2,.y0-2)-step(.w+.h+3,.h+3),rgb(255,255,255),b
line(.x0+.value-2,.y0)-step(.h-1,.h-1),rgb(255,255,255),bf
select case n
case 1,2:t$=right$(str$(1000+.valuescaled),3)+" SEC"
         echo(0,.cx*8,.cy*8-4,t$)
case 3:  locate 1+.cy,1+.cx:if .valuescaled then t$="BRIGHT" else t$="DARKEN"
         echo(0,.cx*8,.cy*8-4,t$) 
case else:
end select
end with
end sub

'@ update slider
sub UpdateSliders(mx as long,my as long)
for i=1 to 10
if ctrl(i).active then
with ctrl(i)
if mx>.x0-.h and my>.y0-2 and mx<.x0+.w+.h and my<.y0+.h+2 then
v=mx-.x0
if v<0 then v=0
if v>99 then v=99
line(.x0+.value-2,.y0)-step(.h-1,.h-1),rgb(0,0,0),bf
.value=v
select case i
  case 1:  videomax=avideomax(int(2*v/25) and 7)
           t$=right$(str$(1000+videomax),3)+" SEC"
  case 2:  darkmax=adarkmax(int(2*v/25) and 7)
           t$=right$(str$(1000+darkmax),3)+" SEC"
  case 3:  dotmode=(v<50):brightness=255-2*v:if dotmode then t$="BRIGHT" else t$="DARKEN"
end select
if i>=1 and i<=3 then echo(0,.cx*8,.cy*8-4,t$)
line(.x0+.value-2,.y0)-step(.h-1,.h-1),rgb(255,255,255),bf
exit for
end if
end with
end if    
next i    
end sub

'@ create button
sub createbutton(n as long,x as long,y as long,tx$)
le=len(tx$)
echo(0,x*8+32-le*4,y*8-4,tx$)
with button(n)
.active=1
.x0=8*x
.y0=8*y-4
.w=64
.h=16
line(.x0,.y0)-step(.w-1,.h-1),rgb(255,255,255),b
end with
end sub

'@ simple buttons action
' button 1 - write ini file and exit
' button 2 - do nothing and exit
sub UpdateButtons(mx as long,my as long)
for i=1 to 10
if button(i).active then
with button(i)
if mx>.x0 and my>.y0 and mx<.x0+.w and my<.y0+.h then
select case i
case 1: wrtini:end
case 2: end
end select
exit for
end if
end with
end if    
next i    
end sub

'@ write .ini file
sub wrtini
r=open(exepath+"\rozenscr.ini", for output, as #2)
? #2,"[Rozen Maiden Slides Screensaver version 2016.june.09 ini file]"
? #2,"videomax=";ctrl(1).value
? #2,"darkmax=";ctrl(2).value
? #2,"dotmode=";ctrl(3).value
close #2
end sub

'@ read .ini file
sub readini
' if .ini file not exist, then create it with default (=0) values
r=open(exepath+"\rozenscr.ini", for input, as #2):close #2
if r then
   wrtini
end if
open exepath+"\rozenscr.ini" for input as #2
while not eof(2)
line input #2,a$:a$=lcase$(a$)
if instr(a$,"videomax=")=1 then
   p=instr(a$,"=")+1:q=val(mid$(a$,p+1))
   if q<0 then q=0
   if q>99 then q=99
   ctrl(1).value=q
   videomax=avideomax(int(2*q/25) and 7)
   ctrl(1).valuescaled=videomax
end if   
if instr(a$,"darkmax=")=1 then
   p=instr(a$,"=")+1:q=val(mid$(a$,p+1))
   if q<0 then q=0
   if q>99 then q=99
   ctrl(2).value=q
   darkmax=adarkmax(int(2*q/25) and 7)
   ctrl(2).valuescaled=darkmax
end if   
if instr(a$,"dotmode=")=1 then
   p=instr(a$,"=")+1:q=val(mid$(a$,p+1))
   if q<0 then q=0
   if q>99 then q=99
   ctrl(3).value=q
   dotmode=(q<50):brightness=255-2*q
   ctrl(3).valuescaled=dotmode
end if   
wend
close #2
end sub


'@ Main part for "/C" program call
function FreeControl as long

screenres 400-16,240,32,1,1*8+4
line (1,1)-(398-16,237),rgb(255,255,255),b

readini
loaddata
' create sliders and buttons
CreateSlider(1,14,23,"PLAY SLIDES"):createbutton(1,38,23,"Save")
CreateSlider(2,14,25,"DARK SCREEN")
CreateSlider(3,14,27,"SCREEN MODE"):createbutton(2,38,27,"Cancel")


randomize timer
videoframe=int(1.0*rnd*25*cnt)

' main loop
do
' next video frame
nextframe2
' make preview frame smaller (h=172, not 192)
dx=(400-16-256)/2
view(dx,8)-(dx+255,171),,rgb(255,255,255)
put (0,0),imgbuf1,pset
view

' poll mouse and controls (4*40=160 millisec delay)
for q=1 to 4
getmouse mx,my,,buttons
if buttons=1 then
  UpdateSliders(mx,my)    
  UpdateButtons(mx,my)    
end if
sleep 40
next q
if inkey$<>"" then
  end
end if
loop
end
FreeControl=0
end function


'main

'r=FreeSaver
'r=FreeControl






